using System.Collections.Generic;
using Verse;
using Verse.AI;

namespace ReinforcementCall
{
	public class JobDriver_UseMissionBoardRC : JobDriver
	{
		public override bool TryMakePreToilReservations(bool errorOnFailed)
		{
			Pawn p = pawn;
			LocalTargetInfo targetA = base.job.targetA;
			Job job = base.job;
			return p.Reserve(targetA, job, 1, -1, null, errorOnFailed);
		}

		protected override IEnumerable<Toil> MakeNewToils()
		{
			this.FailOnDespawnedOrNull(TargetIndex.A);
			yield return Toils_Goto.GotoCell(TargetIndex.A, PathEndMode.InteractionCell);
			Toil openMissionSelect = new Toil();
			openMissionSelect.initAction = delegate
			{
				Pawn actor = openMissionSelect.actor;
				Building missionBoard = (Building)actor.jobs.curJob.GetTarget(TargetIndex.A).Thing;
				StartMissionSelection(missionBoard);
			};
			yield return openMissionSelect;
		}

		public void StartMissionSelection(Building missionBoard)
		{
			Dialog_NodeTree dialog_NodeTree = new Dialog_NodeTree(MissionBoardDialogMakerRC.MissionSelectWindow(missionBoard, pawn.Map), delayInteractivity: true);
			dialog_NodeTree.soundAmbient = MBDefsOf.AmbientMissionBoardRC;
			Find.WindowStack.Add(dialog_NodeTree);
		}
	}
}
